import org.cws.StreamServer;
import org.cws.Stream;

public class JavaDemo
{
    public static void main(String[] args) throws Exception
    {
        int w = 352;
        int h = 288;

        StreamServer s = new StreamServer(8088, "localhost");
        Stream st = new MyStream("Stream from Java", w, h);

        s.addStream(st, "/stream1/");
        s.start();

        int i = 0;
        int x,y;

        int bufsize = w*h*3/2;
        byte[] img = new byte[bufsize];

        int cb_offset = w*h;
        int cr_offset = cb_offset + cb_offset / 4;
        int chroma_offset;

        while (true)
        {
            /* Send frames at roughly 30 fps */
            Thread.sleep(1000/30-2);

            /* prepare synthetic image */

            /* Y */
            for (y = 0; y < h; y++)
            {
                for (x = 0; x < w; x++)
                {
                    img[y * w + x] = (byte)(x + y + i * 3);
                }
            }

            /* Cb and Cr */
            for (y = 0; y < h/2; y++)
            {
                for ( x = 0; x < w/2; x++)
                {
                    chroma_offset = (y * w / 2) + x;
                    img[cb_offset + chroma_offset] = (byte)(128 + y + i * 2);
                    img[cr_offset + chroma_offset] = (byte)(64 + x + i * 5);
                }
            }

            st.sendFrame(w, h, img);
            i++;
        }
    }
}
